<?php

namespace TVn7\TdbBaseBundle\DependencyInjection;

use Symfony\Component\Config\Definition\Builder\TreeBuilder;
use Symfony\Component\Config\Definition\ConfigurationInterface;

/**
 * This is the class that validates and merges configuration from your app/config files
 *
 * To learn more see {@link http://symfony.com/doc/current/cookbook/bundles/extension.html#cookbook-bundles-extension-config-class}
 */
class Configuration implements ConfigurationInterface
{
    /**
     * {@inheritDoc}
     */
    public function getConfigTreeBuilder()
    {
        $treeBuilder = new TreeBuilder();
        $rootNode = $treeBuilder->root('tdb_base');

        $rootNode->children()
                    ->arrayNode('contributors')
                        ->prototype('scalar')
                        ->end()
                    ->end()
                    ->scalarNode('changelog_dir')
                        ->defaultValue('app/changelog')
                        ->validate()
                        ->ifTrue(function($dir) {
                            return !is_dir(__DIR__ . '/../../../../' . stripslashes($dir));
                        })
                            ->thenInvalid("changelog_dir shall be a valid directory")
                        ->end()
                    ->end();


        // Here you should define the parameters that are allowed to
        // configure your bundle. See the documentation linked above for
        // more information on that topic.

        return $treeBuilder;
    }
}
